package websocket

import (
	"encoding/json"
	"github.com/charmbracelet/log"
	"github.com/gorilla/websocket"
	"time"

	"git.smsvc.net/pomodoro/GoTomato/internal/shared"
)

// sends continous messages to all connected WebSocket clients.
func SendPermanentBroadCastMessage() {
	tick := time.NewTicker(time.Second)
	for {
		// Marshal the message into JSON format
		jsonMessage, err := json.Marshal(shared.State)
		if err != nil {
			log.Error("Error marshalling message:", "msg", err)
			return
		}
		// Iterate over all connected clients and broadcast the message
		for _, client := range Clients {
			err := client.SendMessage(websocket.TextMessage, jsonMessage)
			if err != nil {
				log.Error("Error broadcasting to client:", "msg", err)
				// The client is responsible for closing itself on error
			}
		}
		<-tick.C
	}
}
